/*
 * PufferFish.h
 *
 * External variable definitions, structures, #define's and prototypes
 *
 */

extern struct DrawInfo *drawinfo;
extern struct Screen *screen;
extern struct Window *win;
extern struct Image *upimage, *downimage, *frameimage, *frame, *start, *end, *checkimage, *drive, *drivename[], *drive_frame;
extern struct Gadget *uparrows[], *digits[], *downarrows[], *integer[], *prop[], *dest, *format, *drives[];
extern struct IntuiText start_text, end_text, drives_text, drivenames_text[];
extern int start_disknum, end_disknum, dig[];
extern unsigned char avail_disks, drives_selected;
extern char *dig_text[];
extern struct FileRequester *filereq;
extern struct Process *myProc[];
extern struct MsgPort *myPort;
extern int firstdisk, lastdisk;
extern char *contentspath, *formatpath, *lhapath, *brikpath, *additional_device;
extern BOOL verbose;

struct GFMessage {
	struct Message gf_Msg;
	LONG gf_DriveNum;
	STRPTR gf_DiskName;
	STRPTR gf_DiskPath;
	ULONG gf_DiskNumber;
};

#define	GF_IDCMPFLAGS	IDCMP_CLOSEWINDOW | IDCMP_GADGETUP | IDCMP_RAWKEY | IDCMP_VANILLAKEY | IDCMP_GADGETHELP
#define	CONTENTS_PATH	"PufferFish.db"
#define	FORMAT_PATH		"Format NOICONS"
#define	LHA_PATH		"LhA -a x"
#define	BRIK_PATH		"Brik -Cb"
#define	CRC_EXTENSION	".crc"
#define	LHA_EXTENSION	".lha"
#define	MIN_DISK_NUM	1
#define	MAX_DISK_NUM	1000

#define	GF_HELP_MAIN	(0)
#define	GF_HELP_DIGITS	(1)
#define	GF_HELP_DRIVES	(2)
#define	GF_HELP_START	(3)
#if 0
#define	GF_HELP_DEPTH	(4)
#define	GF_HELP_CLOSE	(5)
#define	GF_HELP_DRAGBAR	(6)
#endif

#define	GAD_UPARROW_1	(0)
#define	GAD_UPARROW_2	(1)
#define	GAD_UPARROW_3	(2)
#define	GAD_UPARROW_4	(3)
#define	GAD_UPARROW_5	(4)
#define	GAD_UPARROW_6	(5)
#define	GAD_UPARROW_7	(6)
#define	GAD_UPARROW_8	(7)
#define	GAD_DIGIT_1	(8)
#define	GAD_DIGIT_2	(9)
#define	GAD_DIGIT_3	(10)
#define	GAD_DIGIT_4	(11)
#define	GAD_DIGIT_5	(12)
#define	GAD_DIGIT_6	(13)
#define	GAD_DIGIT_7	(14)
#define	GAD_DIGIT_8	(15)
#define	GAD_DOWNARROW_1	(16)
#define	GAD_DOWNARROW_2	(17)
#define	GAD_DOWNARROW_3	(18)
#define	GAD_DOWNARROW_4	(19)
#define	GAD_DOWNARROW_5	(20)
#define	GAD_DOWNARROW_6	(21)
#define	GAD_DOWNARROW_7	(22)
#define	GAD_DOWNARROW_8	(23)
#define	GAD_INTEGER_1	(24)
#define	GAD_INTEGER_2	(25)
#define	GAD_PROP_1	(26)
#define	GAD_PROP_2	(27)
#define	GAD_DRIVE_0	(28)
#define	GAD_DRIVE_1	(29)
#define	GAD_DRIVE_2	(30)
#define	GAD_DRIVE_3	(31)
#define	GAD_DRIVE_4	(32)
#define	GAD_START	(33)
#define	GF_NUM_GADS	(34)

#define	GF_LEFTBORDER	(drawinfo->dri_Font->tf_XSize + 1)
#define	GF_TOPBORDER	(drawinfo->dri_Font->tf_YSize + 1)
#define	GF_RIGHTBORDER	(drawinfo->dri_Font->tf_XSize + 1)
#define	GF_BOTTOMBORDER	(drawinfo->dri_Font->tf_YSize + 1)

BOOL make_systemimages( void );
void free_systemimages( void );
BOOL make_images( void );
void free_images( void );
BOOL make_digits( void );
void free_digits( void );
BOOL make_drives( void );
void free_drives( void );
BOOL make_gadgets( void );
void free_gadgets( void );
void draw_images( void );
void update_gadgets( ULONG );
void handle_integer( ULONG );
void decrease_digits( ULONG );
void reset_digit( ULONG );
void increase_digits( ULONG );
void handle_prop( ULONG );
void handle_drive( ULONG );
void refresh_gadgets( void );
void update_disknum( void );
BOOL find_disk_path( int, char **, char ** );
unsigned char which_disks( void );
void start_disk_generate( void );
__saveds void generate_disk( void );
BOOL beginWait( struct Window *, struct Requester * );
VOID endWait( struct Window *, struct Requester * );
